<html>
<head>
<title>OGRE: OgreShadowCameraSetupPlaneOptimal.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreShadowCameraSetupPlaneOptimal.h</h1><a href="OgreShadowCameraSetupPlaneOptimal_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ShadowCameraSetupPlaneOptimal_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCameraSetupPlaneOptimal_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreShadowCameraSetup_8h.html">OgreShadowCameraSetup.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00056"></a><a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html" title="Implements the plane optimal shadow camera algorithm.">PlaneOptimalShadowCameraSetup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ShadowCameraSetup.html" title="This class allows you to plug in new ways to define the camera setup when rendering...">ShadowCameraSetup</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">private</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#f78baef232d987b714fe27a4f5e70b14">00059</a>         <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of...">MovablePlane</a>* m_plane;  
<a name="l00060"></a>00060     <span class="keyword">private</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#f08678d2dee8c44a9467aacae33bac39">00061</a>         <a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html" title="Implements the plane optimal shadow camera algorithm.">PlaneOptimalShadowCameraSetup</a>() {}  
<a name="l00062"></a>00062 
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> computeConstrainedProjection( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; pinhole, 
<a name="l00065"></a>00065                                               <span class="keyword">const</span> std::vector&lt;Vector4&gt;&amp; fpoint, 
<a name="l00066"></a>00066                                               <span class="keyword">const</span> std::vector&lt;Vector2&gt;&amp; constraint) <span class="keyword">const</span>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keyword">public</span>:
<a name="l00070"></a>00070         <a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html" title="Implements the plane optimal shadow camera algorithm.">PlaneOptimalShadowCameraSetup</a>(<a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of...">MovablePlane</a> *plane);
<a name="l00072"></a>00072         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html" title="Implements the plane optimal shadow camera algorithm.">PlaneOptimalShadowCameraSetup</a>();
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowCamera (<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a> *sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam, 
<a name="l00076"></a>00076                                       <span class="keyword">const</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> *light, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *texCam) <span class="keyword">const</span>;
<a name="l00077"></a>00077     };
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
